// protectVars.cpp : Defines the entry point for the DLL application.
//

#include "bzfsAPI.h"
#include <fstream>
#include <string>
#include <list>

BZ_GET_PLUGIN_VERSION

std::list<std::string> varsToProtect;
std::list<int> initialPerms;

BZF_PLUGIN_CALL int bz_Load ( const char* commandLine )
{
  bz_debugMessage(4,"protectVars plugin loaded");
  std::ifstream config(commandLine);

  std::string varName;
  while (config >> varName)
  {
    varsToProtect.push_back(varName);
    initialPerms.push_back(bz_getBZDBItemPerms(varName.c_str()));
    bz_setBZDBString(varName.c_str(), bz_getBZDBString(varName.c_str()).c_str(), BZ_BZDBPERM_CLIENT);
  }

  return 0;
}

BZF_PLUGIN_CALL int bz_Unload ( void )
{
  std::list<int>::iterator j = initialPerms.begin();
  for (std::list<std::string>::iterator i = varsToProtect.begin(); i != varsToProtect.end(); i++)
  {
    bz_setBZDBString(i->c_str(), bz_getBZDBString(i->c_str()).c_str(), *j);
    j++;
  }

  bz_debugMessage(4,"protectVars plugin unloaded");
  return 0;
}

// Local Variables: ***
// mode:C++ ***
// tab-width: 8 ***
// c-basic-offset: 2 ***
// indent-tabs-mode: t ***
// End: ***
// ex: shiftwidth=2 tabstop=8

